diff --git a/src/display.c b/src/display.c
index 731062d7..72b56b6e 100644
--- a/src/display.c
+++ b/src/display.c
@@ -780,10 +780,11 @@ get_input(int prompt_position, struct key *key)
 	while (true) {
 		int delay = -1;
 
-		if (opt_refresh_mode == REFRESH_MODE_PERIODIC) {
+		if (opt_refresh_mode != REFRESH_MODE_MANUAL) {
 			bool refs_refreshed = false;
 
-			delay = watch_periodic(opt_refresh_interval);
+			if (opt_refresh_mode == REFRESH_MODE_PERIODIC)
+				delay = watch_periodic(opt_refresh_interval);
 
 			foreach_displayed_view (view, i) {
 				if (view_can_refresh(view) &&
diff --git a/src/stage.c b/src/stage.c
index 2b60e483..a0470ec0 100644
--- a/src/stage.c
+++ b/src/stage.c
@@ -345,8 +345,10 @@ stage_exists(struct view *view, struct status *status, enum line_type type)
 	if (parent == &status_view)
 		return status_exists(parent, status, type);
 
-	if (parent == &main_view)
+	if (parent == &main_view) {
+		refresh_view(&status_view);
 		return main_status_exists(parent, type);
+	}
 
 	return false;
 }
@@ -459,8 +461,10 @@ stage_request(struct view *view, enum request request, struct line *line)
 
 	/* Check whether the staged entry still exists, and close the
 	 * stage view if it doesn't. */
-	if (view->parent && !stage_exists(view, &stage_status, stage_line_type))
+	if (view->parent && !stage_exists(view, &stage_status, stage_line_type)) {
+		stage_line_type = 0;
 		return REQ_VIEW_CLOSE;
+	}
 
 	refresh_view(view);
 
diff --git a/src/watch.c b/src/watch.c
index 14f85b2f..0253435e 100644
--- a/src/watch.c
+++ b/src/watch.c
@@ -104,15 +104,15 @@ static enum watch_trigger
 watch_index_handler(struct watch_handler *handler, enum watch_event event, enum watch_trigger check)
 {
 	enum watch_trigger changed = WATCH_NONE;
-	struct index_diff diff;
+	struct index_diff diff = { 0, 0, 0 };
 
 	if (event == WATCH_EVENT_AFTER_COMMAND)
 		return check_file_mtime(&handler->last_modified, "%s/index", repo.git_dir)
 			? check : WATCH_NONE;
 
-	if (!check_file_mtime(&handler->last_modified, "%s/index", repo.git_dir) ||
-	    event == WATCH_EVENT_SWITCH_VIEW ||
-	    !index_diff(&diff, opt_show_untracked, false))
+	if (event == WATCH_EVENT_SWITCH_VIEW ||
+	    (!check_file_mtime(&handler->last_modified, "%s/index", repo.git_dir) &&
+	     !index_diff(&diff, opt_show_untracked, false)))
 		return WATCH_NONE;
 
 	if (check & WATCH_INDEX_STAGED) {
